//
//  XSPEC12  November 2003
//
//

#include <XSContainer.h>
#include <XSstreams.h>
#include <xsTypes.h>
#include <XSFit/Fit/Fit.h>
#include <XSUtil/FunctionUtils/FunctionUtility.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Model/Model.h>
#include <XSUser/Global/Global.h>
#include <XSUser/Global/XSGlobal.h>


int
XSGlobal::xsXsect(ClientData cdata,Tcl_Interp* tclInterp,int objc, Tcl_Obj* CONST  objv[])
{
   using namespace XSContainer;
   char* cmd (static_cast<char*>(cdata));

   try
   {

      if (objc == 1)
      {
         // report current setting
         tcout << FunctionUtility::XSECT() << ": "
               << FunctionUtility::crossSections(FunctionUtility::XSECT()) 
               << std::endl;
      }
      else if (objc >= 2)
      {
         string arg = string(Tcl_GetString(objv[1])); 
         if ( arg[0] == '?')
         {
            // query options/syntax
            printDocs(cmd,"?");
         }   
         else
         {
            FunctionUtility::crossSections(arg);
            FunctionUtility::XSECT(arg);
            
            // Unfortunately we have no way of knowing at the moment if
            // a model contains a component that is affected by the xsect
            // change.  Therefore we'll just have to recalculate all the
            // models.
            ModelMap::const_iterator itMod = models->modelSet().begin();
            ModelMap::const_iterator itEnd = models->modelSet().end();
            while (itMod != itEnd)
            {
               Model* mod = itMod->second;
               mod->setComputeFlag(true);
               mod->calculate();
               ++itMod;
            }
            fit->Update();
         }   
      }
   }
   catch ( YellowAlert&)
   {
      // catch instances of NoInitializer or InvalidAbundanceTable
      // and return an error.
      return globalData->autoSave(TCL_ERROR);
   }
   return globalData->autoSave(TCL_OK);
}
